; FILENAME      LD51EX2.ASM
; DESCRIPTION   LD51 EXAMPLE 2 (LIGHT & SOUND ON BOARD)
; HARDWARE      ANT-C51M
; ASSEMBLER     SXA51
; START-DATE    01/10/2540
; SOFTWARE ENG  KRIANGSAK B.
; COMPANY       SILA RESEARCH CO.,LTD.
;               TEL 712-2850-2 FAX 381-1447

; ********** VARIABLE SET **********

CONA     EQU    0F800H       ;OUT 0-7=SEGMENT
CONB     EQU    0F801H       ;OUT 0-2=DIGIT 3=SPK 4-7=LED
CONC     EQU    0F802H       ;IN  0-3=KEYIN 4-7=DIPSW
CONP     EQU    0F803H       ;CONTROL PORT

         $INCLUDE "LD51H.ASM"

; ********** RESET ************

         ORG    8100H

RES:     MOV    R2,#80H           ;POWER UP DELAY
RES1:    MOV    R3,#0
         DJNZ   R3,$
         DJNZ   R2,RES1

         MOV    A,#89H            ;SET CONTROL (CONSOLE PORT)
         MOV    DPTR,#CONP
         MOVX   @DPTR,A
         CLR    A                 ;CLEAR SEGMENT
         MOV    DPTR,#CONA
         
; ********** MAIN **********

MAIN:    MOV    B,#4              ;MAIN LOOP
         MOV    R7,#10000000B
         MOV    R6,#20H

MAIN2:   MOV    DPTR,#CONB        ;OUT TO LED
         MOVX   A,@DPTR
         ANL    A,#00001111B
         ORL    A,R7
         MOVX   @DPTR,A

         MOV    A,R6              ;SOUND
         MOV    R2,A
         MOV    R3,#40H
         CALL   SOUND

         MOV    R2,#2             ;DELAY 0.2 SECOND
         CALL   DTSEC

         MOV    A,R7              ;NEXT LOOP
         RR     A
         MOV    R7,A
         MOV    A,R6
         ADD    A,#10H
         MOV    R6,A
         DJNZ   B,MAIN2
         SJMP   MAIN

; ********** SOUND SUB **********
; SOUND GENERATOR
; IN  = R2 FREQUENCY
;     = R3 LENGTH
; REG = A,R2,R3,R4,R5,DPTR

SOUND:   MOV    R5,#0             ;END FLAG
         MOV    R4,#80H           ;DELAY CONSTANT
SOUND1:  CALL   SOUNDS
         CJNE   R5,#1,SOUND1
         RET

SOUNDS:  MOV    DPTR,#CONB        ;OUT 1
         MOVX   A,@DPTR
         SETB   ACC.3
         MOVX   @DPTR,A
         CALL   SOUNDX
         MOV    DPTR,#CONB        ;OUT 0
         MOVX   A,@DPTR
         CLR    ACC.3
         MOVX   @DPTR,A
         CALL   SOUNDX
         RET

SOUNDX:  MOV    A,R2              ;FREQUENCY DELAY
SOUNDX1: CALL   SOUNDY
         DEC    A
         JNZ    SOUNDX1
         RET

SOUNDY:  DJNZ   R4,SOUNDY1        ;LENGTH COUNT DOWN
         MOV    R4,#80H
         DJNZ   R3,SOUNDY1
         MOV    R5,#1
SOUNDY1: RET

         END

